#define DEBUGPRINT

#include <Arduino.h>
#include <NZGateway.h>
#include <EEPROM.h>


#define PARAM_TABLE_SIZE    30

#define UPPER_ADDRESS       0
#define LORA_ADDRESS        0
#define NETWORK_ADDRESS     0

//#define SET_EEPROM
#define READ_EEPROM

NZGateway device(D8, D2);
uint64_t tm = 0;

void init2eeprom(uint8_t upper, uint8_t lora, uint16_t net, char* name, char* model){
    int mem = 0;
    EEPROM.begin(100);
    EEPROM.put(mem++, upper);
    EEPROM.put(mem++, lora);
    EEPROM.put(mem, net);
    mem+=2;

    for (int i = 0; i < 10; i++) EEPROM.put(mem++, name[i]);
    for (int i = 0; i < 10; i++) EEPROM.put(mem++, model[i]);

    EEPROM.commit();
    EEPROM.end();
}

void initFromEeprom(uint8_t& upper, uint8_t& lora, uint16_t& net, char* name, char* model){
    int mem = 0;
    EEPROM.begin(100);
    EEPROM.get(mem++, upper);
    EEPROM.get(mem++, lora);
    EEPROM.get(mem, net);
    mem += 2;
    
    for (int i = 0; i < 10; i++) EEPROM.get(mem++, name[i]);
    for (int i = 0; i < 10; i++) EEPROM.get(mem++, model[i]);

    EEPROM.end();
}



void setup(){

    tm = millis();

    Serial.begin(115200);
    Serial.printf("GATEWAY MAIN\n");
    uint8_t upper, loraaddr;
    uint16_t netaddr;   
    char name[10] = "Gateway";
    char model[10] = "Gt_test";

    #ifdef SET_EEPROM
        init2eeprom(UPPER_ADDRESS, LORA_ADDRESS, (uint16_t)NETWORK_ADDRESS, name, model);
    #endif

    initFromEeprom(upper, loraaddr, netaddr, name, model);
    Serial.printf("\n\n%d %d %d %s %s\n\n", upper, loraaddr, netaddr, name, model);

    Serial.printf("Device initialisation started %d, %d\n", PARAM_TABLE_SIZE, device.paramTable.maxSize);
    uint8_t initstatus = device.init(name, model);
    Serial.printf("Device initialisation completed, status %d\n", initstatus);


}

void loop(){
    device.listenMessages();
    device.listenWeb();
}
