
const device = require('../classes/device')
const LoRaReq = require('../classes/loraReqGenerator')

//Router export
const express = require('express');
const bodyParser = require('body-parser');
var router = express.Router();
module.exports = router

router.use(bodyParser.json({ type: 'json'}));
//app.use(bodyParser.raw());
router.use(bodyParser.text({ type: 'text'}))


messagePrefab = {
    "location" : "unknown",
    "RTC": {
        "date" : "",
        "time": ""
    },
    "system" : {
        "Akey" : "NeKKxx1",
        "Serial" : "1"
    },
    "weather": {

    }
}


function base64ToBytes(base64) {
    const binString = atob(base64);
    return Uint8Array.from(binString, (m) => m.codePointAt(0));
  }

  
function bytesToBase64(bytes) {
    const binString = Array.from(bytes, (x) => String.fromCodePoint(x)).join("");
    return btoa(binString);
}


router.get('/devices', async function(req, res){
    res.status(200);
    res.send(res.app.get('active_devices'))
})

router.post('/devices', bodyParser.json(), async function(req, res){
    res.status(200);
    device_info = req.body;
    active_devices = res.app.get('active_devices')
    console.log(device_info);
    if (device_info['name'] != undefined) active_devices[device_info['address']] = new device(device_info['address'], device_info['name'], device_info['model']);
    else res.status(400);
    res.send();
})

router.post('/telemetry', async function(req, res){
    parameters = req.body;
    console.log(parameters);

    rawMem = base64ToBytes(req.body["value"]);
    let msg =  { ...messagePrefab }
    devices = res.app.get('active_devices')
    dw = new DataView(rawMem.buffer)

    type = Object.values(devices[parameters.address].model.telemetry)[parameters.index]
    
    offset = 0
    switch (type) {
        case "INT8":
            val = dw.getInt8(offset, true);
            offset += 1;
            break;  
        case "FLOAT16":
            val = dw.getInt16(offset, true);
            offset += 2;
            break;  
        case "INT32":
            val = dw.getInt32(offset, true);
            offset += 4;
            break;  
        case "INT64":
            val = dw.getInt64(offset, true);
            offset += 8;
            break;  
        case "FLOAT32":
            val = dw.getFloat32(offset, true);
            offset += 4;
            break;  
        case "FLOAT64":
            val = dw.getFloat64(offset, true);
            offset += 8;
            break;          
        default:
            break;
    } 

    msg.weather[Object.keys(devices[parameters.address].model.telemetry)[parameters.index]] = val;
    msg.system.Serial = parameters.address


    const req_content = {
        method: 'POST',
        headers: {
            'Content-Type': 'application/json'
        },
        body: JSON.stringify(msg)
    }

    await fetch("http://62.122.196.31/core/jsonadd.php", req_content);

    res.status(200);
    res.send();
})

router.post('/telemetry_full', async function(req, res){
    parameters = req.body;
    console.log(parameters);

    rawMem = base64ToBytes(req.body["value"]);
    let msg =  { ...messagePrefab }

    devices = res.app.get('active_devices')

    dw = new DataView(rawMem.buffer)

    console.log(rawMem);

    let offset = 0;
    for (let k of Object.keys(devices[parameters['address']].model.telemetry)){
        let v = devices[parameters['address']].model.telemetry[k]
        switch (v) {
            case "INT8":
                val = dw.getInt8(offset, true);
                offset += 1;
                break;  
            case "FLOAT16":
                val = dw.getInt16(offset, true);
                offset += 2;
                break;  
            case "INT32":
                val = dw.getInt32(offset, true);
                offset += 4;
                break;  
            case "INT64":
                val = dw.getInt64(offset, true);
                offset += 8;
                break;  
            case "FLOAT32":
                val = dw.getFloat32(offset, true);
                offset += 4;
                break;  
            case "FLOAT64":
                val = dw.getFloat64(offset, true);
                offset += 8;
                break;          
            default:
                break;
        } 

        msg.weather[k] = val;
        msg.system.Serial = parameters.address
    }

    console.log(msg)


    const req_content = {
        method: 'POST',
        headers: {
            'Content-Type': 'application/json'
        },
        body: JSON.stringify(msg)
    }
    
    await fetch("http://62.122.196.31/core/jsonadd.php", req_content);


    res.status(200);
    res.send();
})

router.post('/connect_device', async function(req, res){
    res.status(200);
    device_info = req.body;
    active_devices = res.app.get('active_devices')
    console.log(device_info);
    if (device_info['name'] != undefined) active_devices[device_info['address']] = new device(device_info['address'], device_info['name'], device_info['model']);
    else res.status(400);
    res.send();
})

router.post('/connect_gateway', async function(req, res){
    parameters = req.body;
    console.log(parameters);

    res.status(200);
    res.send();
})

router.post('/disconnect', async function(req, res){
    active_devices = res.app.get('active_devices')
    parameters = req.body;
    delete active_devices[parameters["address"]]
    res.status(200);
    res.send();
})


