#ifndef CUSTOMFIELD_H
#define CUSTOMFIELD_H

#include <Arduino.h>

#define     INT8_TYPE       0
#define     INT16_TYPE      1
#define     INT32_TYPE      2
#define     INT64_TYPE      3
#define     FLOAT32_TYPE    4
#define     FLOAT64_TYPE    5

#define     MAX_NAME_SIZE   30


struct CustomField{
    void* mem;
    uint8_t type;
    char name[MAX_NAME_SIZE];
    bool isActual;

    void setData(uint8_t type, const char* name = NULL, void* mem = NULL);

    uint8_t valueSize();

    uint8_t nameSize();

    void updateValue(void* mem);

    uint8_t bufferWriteValue(uint8_t* buf);

    uint8_t bufferWriteInfo(uint8_t* buf);

    void print();
};

struct CustomParam : CustomField {

    void* onChangeHandler;

    void setData(uint8_t type, void* onChangeHandler, const char* name = NULL, void* mem = NULL);

};

#endif