#ifndef CUSTOMFIELDTABLE_H
#define CUSTOMFIELDTABLE_H

#include <CustomField.h>


class CustomFieldTable{

public:

    CustomFieldTable(uint8_t maxSize);
    
    CustomField& operator[](uint8_t pos);

    uint8_t indexOf(char* name);

    uint32_t transmitedInfoSize();

    uint32_t transmitedDataSize();

    uint8_t bufferWriteData(uint8_t* buffer);

    uint8_t bufferWriteInfo(uint8_t* buffer);

    uint8_t add(uint8_t type, char* name = NULL, void* mem = NULL);

    void print();

    CustomField* table;
    uint8_t maxSize;
    uint8_t size;

};

class CustomParamTable{

public:

    CustomParamTable(uint8_t maxSize);
    
    CustomParam& operator[](uint8_t pos);

    uint8_t indexOf(char* name);

    uint32_t transmitedInfoSize();

    uint32_t transmitedDataSize();

    uint8_t bufferWriteData(uint8_t* buffer);

    uint8_t bufferWriteInfo(uint8_t* buffer);

    uint8_t add(uint8_t type, void* onChangeHandler = NULL, const char* name = NULL, void* mem = NULL);

    void print();

    CustomParam* table;
    uint8_t maxSize;
    uint8_t size;


};

#endif