#ifndef NZGATEWAY_H
#define NZGATEWAY_H

#include <NZdevice.h>

#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>
#include <ESP8266WebServer.h>
#include <WiFiClient.h>
#include <ArduinoJson.h>

#define JSON_BUFFER_SIZE 1024



class NZGateway : public NZDevice {

public:

    NZGateway(uint8_t SSPin, uint8_t DIOPin);

    uint8_t init(char* name, char* model);

    uint8_t initWiFi(char* ssid, char* password);

    uint8_t initWeb();

    uint8_t initServer();

    void listenMessages();

    void processMessage(uint16_t addr);

    void set_param_handler();



    uint16_t sendRawStringHTTP(uint8_t* mem, const char* url, const char* method);

    uint16_t sendJSONStringHTTP(uint8_t* mem, const char* url, const char* method);

    void listenWeb();

    WiFiClient wifiClient;
    HTTPClient httpClient;
    ESP8266WebServer webServer;


protected:

    StaticJsonDocument<JSON_BUFFER_SIZE> _jsonDoc;
    NZNet messageManager;

};

#endif